$error = loadRequiredAddon("Server_Pets"); // Make sure the pet system is loaded first.

if($error == $Error::AddOn_Disabled || $error == $Error::AddOn_NotFound)
{
	return; // Don't load this file if the pet system isn't going to be loaded.
}

// Custom pet tutorial!
// To register a custom pet, we just use the addCustomPet() function and fill in the variables with the appropriate information.
// The first argument is the single-word name of the animal, which players will use in the commands to buy and summmon it.
// The second argument is a string which is the pet's default name, which shows up over it's head when it spawns.
// The third argument is the UI name of the datablock in quotes (the name that shows up in the playertype list), OR you can specify the datablock name without quotes.
// The fourth argument is the price in points that it costs to buy the pet. If you don't want any pets to cost money, enter $pref::server::pets::freePets=true; into your console.

// The rest of the aruments from here are optional and just for extra customization. You can exclude one by just entering "" instead of a value for that spot. Remember, while you can exclude values after the one you specify, you cannot exclude any of the values before it as the value must match the same 'slot' in the function arguments.
// The fifth value is the scale of the pet, or more simply put, the size of the pet. You can put in a decimal number from 0.01 to 5 here to specify how large the pet should be, with 1 being 'normal'. (Tip: You can also use quotes to insert a vector value if you want to scale it differently on a specific axis.)
// The sixth argument is a true or false which specifies if the pet can be recolored or not. This depends on the model, set to true if you're not sure.
// The seventh argument specifys what color the pet will be by default. Leave as "" to keep as default. This doesn't do anything if you set the last argument to false. (Tip: Set to an RGBA value to use a specific color. If you don't know what an RGBA value is, look it up on google. To be clear, all three values are decimal numbers between 0 and 1. So if you get your RGBA value and it's something higher than one, divide the number by 255 in a calculator to get the decimal you need for this. Also, the alpha value [the fourth value] should always be 1 unless you intend to make the pet transparent. Example value: "1 0 0 1" is red.)
// The eigth argument is the pet's shapename color. You should leave this default, just enter "" for this argument. (Tip: If you want a custom shapename color, enter a three-value RGB value.)
// The ninth value is an optional string specifying the animation threads the pet should play from when it isn't active. If in doubt, just leave this value as "".

// Here is an example pet which is basically just the default horse and uses only the required arguments.
// The name "horse" will be used in the pet shop and for the herepet command, it will use the datablock with the uiname "Horse", the name of it will start as "Player's sturdy horse", and it will cost 80 points.

// Remove the slashes at the beginning of these examples to use them. You need the horse enabled for them to work.
//addCustomPet("horse", "sturdy horse", "Horse", 80);

// Here is another example using just the first optional argument to change the scale. We added the 3 at the end to specify making the horse 3 times larger than it's default size.
// addCustomPet("gianthorse", "city stomping horse", "Horse", 120, 3);

// For this horse we'll give it a custom starting color. It'll be 0.8 times it's normal size and should look relatively pink.
// addCustomPet("coloredHorse", "flamboyant horse", "Horse", 50, 0.8, "", "1 0.4 1 1");

// And finally we'll make a strange being using all the custom options
// addCustomPet("weird", "arcane anomaly", "Standard Player", 60, "0.4 0.01 0.7", true, "0.1 0.05 0 0.9", "0.3 0 0", "run headside armattack talk");

// You can also examine defaultpets.cs to see how the default pets are defined (Note: Always use addCustomPet() if you are defining a pet from a different add-on)
