if(isObject(SwiftDragonArmor))
	return;
	
// Load dts shapes and merge animations
datablock TSShapeConstructor(SwiftDragonDts)
{
	baseShape  = "./SWIFTdragon18.dts";
	sequence0  = "./Sdrag_root.dsq root";

	sequence1  = "./Sdrag_run2.dsq run";
	sequence2  = "./Sdrag_run2.dsq walk";
	sequence3  = "./Sdrag_back.dsq back";
	sequence4  = "./Sdrag_side.dsq side";

	sequence5  = "./Sdrag_crouch.dsq crouch";
	sequence6  = "./Sdrag_crouchMove.dsq crouchRun";
	sequence7  = "./Sdrag_crouchBack.dsq crouchBack";
	sequence8  = "./Sdrag_crouchSide.dsq crouchSide";

	sequence9  = "./Sdrag_look.dsq look";
	sequence10 = "./Sdrag_headside.dsq headside";
	sequence11 = "./Sdrag_root.dsq headUp";

	sequence12 = "./Sdrag_jump.dsq jump";
	sequence13 = "./Sdrag_jumpStand.dsq standjump";
	sequence14 = "./Sdrag_fall.dsq fall";
	sequence15 = "./Sdrag_root.dsq land";

	sequence16 = "./Sdrag_root.dsq armAttack";
	sequence17 = "./Sdrag_root.dsq armReadyLeft";
	sequence18 = "./Sdrag_root.dsq armReadyRight";
	sequence19 = "./Sdrag_root.dsq armReadyBoth";
	sequence20 = "./Sdrag_fire_charge.dsq spearready";
	sequence21 = "./Sdrag_fireHEAVY.dsq spearThrow";

	sequence22 = "./Sdrag_fireLIGHT.dsq talk";

	sequence23 = "./Sdrag_death1.dsq death1";

	sequence24 = "./Sdrag_root.dsq shiftUp";
	sequence25 = "./Sdrag_root.dsq shiftDown";
	sequence26 = "./Sdrag_fireLIGHT.dsq shiftAway";
	sequence27 = "./Sdrag_root.dsq shiftTo";
	sequence28 = "./Sdrag_wingSlash_L.dsq shiftLeft";
	sequence29 = "./Sdrag_wingSlash_R.dsq shiftRight";
	sequence30 = "./Sdrag_root.dsq rotCW";
	sequence31 = "./Sdrag_root.dsq rotCCW";

	sequence32 = "./Sdrag_root.dsq undo";
	sequence33 = "./Sdrag_root.dsq plant";

	sequence34 = "./Sdrag_sit2.dsq sit";

	sequence35 = "./Sdrag_root.dsq wrench";

   sequence36 = "./Sdrag_bite.dsq activate";
   sequence37 = "./Sdrag_bite.dsq activate2";

   sequence38 = "./Sdrag_root.dsq leftrecoil";

   sequence39 = "./Sdrag_flap.dsq fly";
//   sequence40 = "./Sdrag_idle1.dsq Idle";

   sequence40 = "./Sdrag_sit.dsq sit2";
   sequence41 = "./Sdrag_sit3.dsq sit3";
   sequence42 = "./Sdrag_sleep.dsq sleep";
//   sequence43 = "./Sdrag_stand.dsq stand";
   sequence43 = "./Sdrag_rest.dsq rest";
   sequence44 = "./Sdrag_boost.dsq boost";
};

//Sounds

datablock AudioProfile(SwiftDragonJumpSound)
{
	fileName = "./jumpAirDragon.wav";
	description = AudioClose3d;
	preload = true;
};

datablock PlayerData(SwiftDragonArmor : PlayerStandardArmor)
{
   renderFirstPerson = false;
//   emap = false;

//   className = Armor;
   shapeFile = "./SWIFTdragon18.dts";
   cameraMaxDist = 8;
   cameraTilt = 0.261;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 2.3;
//   computeCRC = false;

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;

   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = horseDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 2.0;

   mass = 80;
   drag = 0.028;			//0.5
   density = 0.7;		//0.1
   maxDamage = 260;		//240
   maxEnergy =  130;
//   repairRate = 0.33;
	airControl = 0.25;

   rechargeRate = 0.4;

   runForce = 80 * 80;	//60 * 80
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 20;
   maxBackwardSpeed = 15;
   maxSideSpeed = 12;

   maxForwardCrouchSpeed = 6;
   maxBackwardCrouchSpeed = 5;
   maxSideCrouchSpeed = 5;

//   maxForwardProneSpeed = 0;
//   maxBackwardProneSpeed = 0;
//   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 6;
   maxBackwardWalkSpeed = 6;
   maxSideWalkSpeed = 6;

   maxUnderwaterForwardSpeed = 10;
   maxUnderwaterBackwardSpeed = 10;
   maxUnderwaterSideSpeed = 10;

   jumpForce = 20 * 80; //20 * 80;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   minImpactSpeed = 250;		//250
   speedDamageScale = 1;		//3.8

   boundingBox			= vectorScale("4.2 4.2 1.9", 4);	//4.25 4.25 1.9
   crouchBoundingBox	= vectorScale("4.2 4.2 1.4", 4);	//4.25 4.25 1.4

//   pickupRadius = 0.75;

   // Foot Prints
   //decalData   = SwiftDragonFootprint;
   //decalOffset = 0.25;

   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;

   //footPuffEmitter = LightPuffEmitter;
//   footPuffNumParts = 10;
//   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

//   splash = PlayerSplash;
//   splashVelocity = 4.0;
//   splashAngle = 67.0;
//   splashFreqMod = 300.0;
//   splashVelEpsilon = 0.60;
//   bubbleEmitTime = 0.1;
//   splashEmitter[0] = PlayerFoamDropletsEmitter;
//   splashEmitter[1] = PlayerFoamEmitter;
//   splashEmitter[2] = PlayerBubbleEmitter;
//   mediumSplashSoundVelocity = 10.0;
//   hardSplashSoundVelocity = 20.0;
//   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
//   runSurfaceAngle  = 85;
//   jumpSurfaceAngle = 90;

//   minJumpSpeed = 20;
//   maxJumpSpeed = 30;

//   horizMaxSpeed = 250;
//   horizResistSpeed = 180;
//   horizResistFactor = 0.1;

//   upMaxSpeed = 200;
//   upResistSpeed = 50;
//   upResistFactor = 0.1;

//   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

	JumpSound			= "";

   // Footstep Sounds
//   FootSoftSound        = SwiftDragonFootFallSound;
//   FootHardSound        = SwiftDragonFootFallSound;
//   FootMetalSound       = SwiftDragonFootFallSound;
//   FootSnowSound        = SwiftDragonFootFallSound;
//   FootShallowSound     = SwiftDragonFootFallSound;
//   FootWadingSound      = SwiftDragonFootFallSound;
//   FootUnderwaterSound  = SwiftDragonFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;

//   impactWaterEasy      = Splash1Sound;
//   impactWaterMedium    = Splash1Sound;
//   impactWaterHard      = Splash1Sound;

//   groundImpactMinSpeed    = 10.0;
//   groundImpactShakeFreq   = "4.0 4.0 4.0";
//  groundImpactShakeAmp    = "1.0 1.0 1.0";
//   groundImpactShakeDuration = 0.8;
//   groundImpactShakeFalloff = 10.0;

   //exitingWater         = ExitingWaterLightSound;

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;

	uiName = "";
	rideable = false;
		lookUpLimit = 0.6;
		lookDownLimit = 0.1;

	canRide = false;
	showEnergyBar = true;
	paintable = false;

//	brickImage = horseBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 0;
//   mountThread[0] = "root";
//   mountNode[0] = 2;

	useCustomPainEffects = true;
//	PainHighImage = "";
//	PainMidImage  = "";
//	PainLowImage  = "";
	painSound     = "DragonPainSound";
	deathSound    = "DragonDeathSound";
};

//function SwiftDragonArmor::OnnewDatablock(%this,%obj)
//{
//	%obj.playThread(0, Idle);
//}


function SwiftDragonArmor::onTrigger(%this, %obj, %trig, %press) {
	if(%trig == 2 && %press && getsimtime() >= %obj.lastjump+1300)	//1500
	{
		//flap code goes here. What follows is a recreation of the standard jump on a standard armor MINUS a check to be sure we're touching the ground - flying is possible with this.

		//pretty sure it doesn't play a sound either, because, again, I didn't need it for my purposes.
		%obj.forbidJump = false;		//Not sure what this line does. Might be causing the jump issues
		%obj.addVelocity("0 0 5");		//0 0 10
		%obj.playThread(2, "fly"); //animation
//		schedule(1500,%obj.playThread(2, "root"),%obj);
		ServerPlay3D(SwiftDragonJumpSound, %obj.getPosition());
		%obj.lastjump = getsimtime();
	}
	else Parent::onTrigger(%this, %obj, %trig, %press);
}

function allowJump(%obj) {
	if(!isObject(%obj))
		return;
	%obj.forbidJump = false;
}
