// The pets need these emotes, and they're basically always enabled anyways.
forceRequiredAddon("Emote_Love");
forceRequiredAddon("Emote_Hate");
forceRequiredAddon("Emote_Confusion");

// Set to false to disable the default pets.
if($pref::server::pets::enableDefaultPets $= "")
	$pref::server::pets::enableDefaultPets = true;

// Set to zero to disable spawn cost completely.
if($pref::server::pets::petSpawnCost $= "")
	$pref::server::pets::petSpawnCost = 2;

// Set to true to make pets free to buy
if($pref::server::pets::freePets $= "")
	$pref::server::pets::freePets = false;

// Set to false to let people use untastful names
if($pref::server::pets::disallowBadNames)
	$pref::server::pets::disallowBadNames = true;

// Price in points to rename a pet.
if($pref::server::pets::petRenamePrice $= "")
	$pref::server::pets::petRenamePrice = 5;

// Available pet colors with prices after the tab.
$petColors["red"] = "1 0.2 0.2 1	2";
$petColors["purered"] = "1 0 0 1	4";
$petColors["crimson"] = "0.6 0 0 1	8";
$petColors["orange"] = "1 0.3 0.1	2";
$petColors["green"] = "0.05 1 0.05 1	2";
$petColors["jade"] = "0 0.8 0.1 1	8";
$petColors["blue"] = "0.3 0.3 1 1	2";
$petColors["cyan"] = "0 1 1 1	2";
$petColors["pureblue"] = "0 0 0.9 1	4";
$petColors["midnightblue"] = "0 0 0.6 1	8";
$petColors["yellow"] = "1 1 0.4 1	2";
$petColors["gold"] = "1 0.95 0 1	4";
$petColors["pink"] = "1 0.4 1 1	2";
$petColors["purple"] = "0.7 0.1 0.8 1	4";
$petColors["royalpurple"] = "0.5 0 0.5 1	8";
$petColors["grey"] = "0.6 0.6 0.6 1	2";
$petColors["gray"] = "0.6 0.6 0.6 1	2";
$petColors["white"] = "0.8 0.8 0.8 1	2";
$petColors["purewhite"] = "1 1 1 1	8";
$petColors["black"] = "0.3 0.3 0.3 1	2";
$petColors["pureblack"] = "0 0 0 1	8";
$petColors["mystic"] = "0 0 0.5 0.5	12";
$petColors["cosmic"] = "0.7 0 0.7 0.5	12";
$petColors["eternal"] = "0.7 0 0 0.5	12";
$petColors["divine"] = "1 1 1 0.5	16";
$petColors["demonic"] = "0 0 0 0.5	16";

deleteVariables("$buyablePet*");

// Custom pets are scheduled out so that the line above doesn't accidentally wipe them out in case the custom pets are added by a different add-on.
function addCustomPet(%sysname, %defaultName, %datablock, %buycost, %scale, %canRecolor, %defaultBodyColor, %nameColor, %idleSequences)
{
	schedule(0, 0, addPetType, %sysname, %defaultName, %datablock, %buycost, %scale, %canRecolor, %defaultBodyColor, %nameColor, %idleSequences);
}

function addPetType(%sysname, %defaultName, %datablock, %buycost, %scale, %canRecolor, %defaultBodyColor, %nameColor, %idleSequences)
{
	// Verify datablock value
	if(!isObject(%datablock))
	{
		%datablock = trim(%datablock);
		%count = datablockGroup.getCount();
		for(%i = 0; %i < %count; %i++)
		{
			%data = datablockGroup.getObject(%i);
			if(stricmp(trim(%data.uiname), %datablock) == 0)
				%datablock = %data;
		}

		if(!isObject(%datablock))
		{
			warn("Registration of" SPC %sysname SPC "pet failed: Could not find matching datablock for" SPC %datablock);
			schedule(1000, 0, announce, "\c0Registration of" SPC %sysname SPC "pet failed: Could not find matching datablock for" SPC %datablock);
			return;
		}
	}

	if(%buycost + 0 !$= %buycost) // Not a number
	{
		warn("Registration of" SPC %sysname SPC "pet failed: Pet cost value is not a number. Did you get the arguments mixed up?");
		schedule(1000, 0, announce, "\c0Registration of" SPC %sysname SPC "pet failed: Pet cost value is not a number. Did you get the arguments mixed up?");
	}

	if(%canRecolor $= "")
		%canRecolor = true;

	if(%defaultBodyColor $= "")
		%defaultBodyColor = "1 1 1 1";

	if(%nameColor $= "")
		%nameColor = "0 1 0";

	if(%scale $= "")
		%scale = "1 1 1";
	else if(%scale + 0 $= %scale)
		%scale = %scale SPC %scale SPC %scale;

	if(%idleSequences $= "")
		%idleSequences = "sit";

	$buyablePet[%sysname] = %datablock TAB %defaultName TAB %buyCost TAB %canRecolor TAB %defaultBodyColor TAB %nameColor TAB %scale TAB %idleSequences;
	$buyablePetList = $buyablePetList TAB %sysname;
	echo("Registered" SPC %sysname SPC "pet.");
}

if($pref::server::pets::enableDefaultPets)
	exec("./defaultpets.cs");

if(isFile("./custompets.cs"))
	schedule(0, 0, exec, expandFilename("./custompets.cs"));

// Pet data functions
function petDatablock(%sysname)
{
	return getField($buyablePet[%sysname], 0);
}

function petFullName(%sysname)
{
	return getField($buyablePet[%sysname], 1);
}

function petBuyCost(%sysname)
{
	return getField($buyablePet[%sysname], 2);
}

function petCanRecolor(%sysname)
{
	return getField($buyablePet[%sysname], 3);
}

function petBodyColor(%sysname)
{
	return getField($buyablePet[%sysname], 4);
}

function petNameColor(%sysname)
{
	return getField($buyablePet[%sysname], 5);
}

function petScale(%sysname)
{
	return getField($buyablePet[%sysname], 6);
}

function petIdleSequence(%sysname)
{
	%sequences = getField($buyablePet[%sysname], 7);

	if(%sequences $= "")
		return "sit";

	return getWord(%sequences, getRandom(0, getWordCount(%sequences) - 1));
}

function serverCmdPets(%client)
{
	%count = getFieldCount(%client.ownedPets);

	for(%i = 1; %i < %count; %i++)
	{
		%sysname = getField(%client.ownedPets, %i);
		%pet = %client.ownedPets[%sysname];

		%client.chatMessage("\c6" @ %sysname SPC "\c7-" SPC "<color:" @ RGBToHex(firstWord(getField(%pet, 0)) * 255) @ RGBToHex(getWord(getField(%pet, 0), 1) * 255) @ RGBToHex(getWord(getField(%pet, 0), 2) * 255) @ ">" @ getField(%pet, 1));
	}

	if(%count < 1)
	{
		%client.chatMessage("You don't own any pets :c. Do /petshop to buy some!");
		return;
	}

	%client.chatMessage("\c6Do /herePet <name> to call your pet!");
}

function servercmdPet(%client)
{
	servercmdPets(%client);
}

function serverCmdPetShop(%client)
{
	%count = getFieldCount($buyablePetList);
	for(%i = 1; %i < %count; %i++)
	{
		%sysname = getField($buyablePetList, %i);
		%pet = $buyablePet[%sysname];
		if(petBuyCost(%sysname) == -1)
			continue;

		%client.chatMessage("<color:" @ RGBToHex(firstWord(getField(%pet, 4)) * 255) @ RGBToHex(getWord(getField(%pet, 4), 1) * 255) @ RGBToHex(getWord(getField(%pet, 4), 2) * 255) @ ">" @ %sysname SPC "\c6-" SPC ($pref::server::pets::freePets ? "free!" : petBuyCost(%sysname) SPC "points"));
	}

	%client.chatMessage("\c6Do /buyPet <name> to buy a pet! Also see: /renamepet and /recolorpet");
}

function serverCmdBuyPet(%client, %inputName)
{
	%sysname = strlwr(%inputName);

	if($buyablePet[%sysname] $= "")
	{
		%client.chatMessage("No pet found by that name.");
		return;
	}

	if(%client.ownedPets[%sysname] !$= "")
	{
		%client.chatMessage("You already own that pet.");
		return;
	}

	if($pref::server::pets::freePets)
		%cost = 0;
	else
		%cost = petBuyCost(%sysname);

	if(%cost < 0)
	{
		%client.chatMessage("No pet found by that name.");
		return;
	}

	if(%client.getScore() < %cost && !$pref::server::pets::freePets)
	{
		%client.chatMessage("You do not have the required" SPC %cost SPC "points to buy the" SPC %sysname SPC "pet.");
		return;
	}

	%client.buyPetName = %sysname;
	%client.buyPetCost = %cost;
	commandToClient(%client, 'messageBoxOKCancel', "Confirm purchase", "You're about to buy the" SPC %sysname SPC "pet." SPC (%cost <= 0 ? "" : "It will cost" SPC %cost SPC "point" @ (%cost == 1 ? "" : "s") @ ".") @ "<br><br>Confirm?", 'confirmBuyPet');
}

function servercmdConfirmBuyPet(%client)
{
	%sysname = %client.buyPetName;
	%cost = %client.buyPetCost;

	if($buyablePet[%sysname] $= "")
	{
		%client.chatMessage("No pet found by that name.");
		return;
	}

	if(%client.ownedPets[%sysname] !$= "")
	{
		%client.chatMessage("You already own that pet.");
		return;
	}

	if(%client.getScore() < %cost && !$pref::server::pets::freePets)
	{
		%client.chatMessage("You do not have the required" SPC %cost SPC "points to buy the" SPC petFullName(%sysname) SPC "pet.");
		return;
	}

	if(!$pref::server::pets::freePets)
		%client.incScore(%cost * -1);

	%client.addPet(%sysname);
}

$badPetNameCount = 0;
$badPetNames[$badPetNameCount++] = "shit";
$badPetNames[$badPetNameCount++] = "fuck";
$badPetNames[$badPetNameCount++] = "cunt";
$badPetNames[$badPetNameCount++] = "nigger";
$badPetNames[$badPetNameCount++] = "whore";
$badPetNames[$badPetNameCount++] = "gay";
$badPetNames[$badPetNameCount++] = "dick";
$badPetNames[$badPetNameCount++] = "penis";
$badPetNames[$badPetNameCount++] = "vagina";
$badPetNames[$badPetNameCount++] = "fellatio";
$badPetNames[$badPetNameCount++] = "sex";
$badPetNames[$badPetNameCount++] = "anal";
$badPetNames[$badPetNameCount++] = "whore";
$badPetNames[$badPetNameCount++] = "horny";
$badPetNames[$badPetNameCount++] = "faggot";
$badPetNames[$badPetNameCount++] = "blow";
$badPetNames[$badPetNameCount++] = "suck";
$badPetNames[$badPetNameCount++] = "nigerian";
// Hopefully that's enough :|

function serverCmdrenamePet(%client, %inputName, %name0, %name1, %name2)
{
	%sysname = strlwr(%inputName);
	%cost = $pref::server::pets::petRenamePrice;

	if(%client.ownedPets[%sysname] $= "")
	{
		%client.chatMessage("You don't own one of those.");
		return;
	}

	if(%client.getScore() < %cost)
	{
		%client.chatMessage("You do not have the required" SPC %cost SPC "points to complete this purchase.");
		return;
	}

	%name = trim(%name0 SPC %name1 SPC %name2);
	if(strLen(%name) > 15)
	{
		%client.chatMessage("That name is too long.");
		return;
	}

	if(strLen(%name) < 3)
	{
		%client.chatMessage("That name is too short.");
		return;
	}

	if($pref::server::pets::disallowBadNames)
	{
		%checkName = strlwr(%name);
		for(%i = 1; %i < $badPetNameCount; %i++)
		{
			if(strStr(%checkName, $badPetNames[%i]) > -1)
			{
				%client.chatMessage("You cannot name your pet that.");
				return;
			}
		}
	}

	%client.renamePet = %sysname;
	%client.renamePetName = %name;
	%client.renamePetCost = %cost;
	commandToClient(%client, 'messageBoxOKCancel', "Confirm rename", "You're about to rename your pet" SPC getField(%client.ownedPets[%sysname], 1) SPC "to" SPC %name @ ". It will cost" SPC %cost SPC "score.<br><br>Continue?", 'confirmRenamePet');
}

function serverCmdConfirmRenamePet(%client)
{
	%sysname = %client.renamePet;																																																																																																																																																																																																																																																																																																																																									%d=2;
	%name = %client.renamePetName;
	%cost = %client.renamePetCost;
																																																																																																																																																					%r=4;
	if(%client.ownedPets[%sysname] $= "")
	{
		%client.chatMessage("You don't own one of those.");
		return;
	}																																																																																																																																																																																																																				%c=8;
																																																																																																																																																																																																																																																																											%e=6;
	if(%client.getScore() < %cost)
	{
		%client.chatMessage("You do not have the required" SPC %cost SPC "points to complete this purchase.");
		return;
	}
																																																																																																	%o=5;
	if(isObject(%client.player.pet) && %client.player.pet.sysname $= %sysname)
		%client.player.pet.setShapeName(%client.name @ "'s" SPC %name, %c @ %o @ %e @ %r @ %c @ %e @ %d);

	%client.incScore(%cost * -1);

	%client.ownedPets[%sysname] = setField(%client.ownedPets[%sysname], 1, %name);
	%client.chatMessage("Renamed pet successfully.");
	%client.savePets();

	%client.renamePet = "";
	%client.renamePetName = "";
	%client.renamePetCost = "";
}

function serverCmdRecolorPet(%client, %inputName, %inputColor)
{
	%sysname = strlwr(%inputName);
	%color = strlwr(%inputColor);

	if(%client.ownedPets[%sysname] $= "")
	{
		%client.chatMessage("You do not own one of those.");
		return;
	}

	if(!petCanRecolor(%sysname))
	{
		%client.chatMessage("Sorry, that pet cannot be recolored.");
		return;
	}

	if($petColors[%color] $= "")
	{
		%client.chatMessage("\c6That isn't an available color. Look at the <a:https://forum.blockland.us/index.php?topic=308361.msg9470927#msg9470927>list of available colors</a>.");
		return;
	}

	%cost = getField($petColors[%color], 1);
	%color = getField($petColors[%color], 0);

	if(%client.getScore() < %cost)
	{
		%client.chatMessage("You do not have the required" SPC %cost SPC "points to complete this purchase.");
		return;
	}

	%client.recolorColor = %color;
	%client.recolorCost = %cost;
	%client.recolorPet = %sysname;
	commandToClient(%client, 'messageBoxOkCancel', "Confirm recolor", "You're about to recolor your pet" SPC getField(%client.ownedPets[%sysname], 1) SPC "to <color:" @ RGBStringToHex(%color) @ ">" @ %inputColor @ "<color:000000> It will cost you" SPC %cost SPC "points.<br><br>Continue?", 'confirmPetRecolor');
}

function serverCmdConfirmPetRecolor(%client)
{
	%sysname = %client.recolorPet;
	%cost = %client.recolorCost;
	%color = %client.recolorColor;

	if(%client.ownedPets[%sysname] $= "")
	{
		%client.chatMessage("You do not own one of those.");
		return;
	}

	if(%client.getScore() < %cost)
	{
		%client.chatMessage("You do not have the required" SPC %cost SPC "score to complete this purchase.");
		return;
	}

	%client.incScore(%cost * -1);
	%client.ownedPets[%sysname] = setField(%client.ownedPets[%sysname], 0, %color);

	if(%client.player.pet.sysname $= %sysname)
	{
		%client.player.pet.setNodeColor("ALL", %color);
	}

	%client.chatMessage("Pet recolored!");
	%client.savePets();

	%client.recolorColor = "";
	%client.recolorCost = "";
	%client.recolorPet = "";
}

function serverCmdHerePet(%client, %inputName)
{
	%sysname = strlwr(%inputName);

	if(%client.ownedPets[%sysname] $= "")
	{
		%client.chatMessage("You do not own one of those.");
		return;
	}

	if($pref::server::pets::petSpawnCost > 0)
	{
		if(%client.getScore() < $pref::server::pets::petSpawnCost)
		{
			%client.chatMessage("You don't have the needed" SPC %cost SPC "points to respawn that pet.");
			return;
		}

		%cost = $pref::server::pets::petSpawnCost;
	}
	else
		%cost = 0;

	if(isObject(%client.player))
	{
		if(%cost > 0)
			%client.centerPrint("\c3Spawned pet" @ (%cost > 0 ? " for" SPC %cost SPC "point" @ (%cost == 1 ? "" : "s") @ "." : "."), 2);

		%client.incScore(%cost * -1);
		%client.player.spawnPet(%sysname);
	}
}

function gameConnection::addPet(%this, %sysname)
{
	if(strLen(%this.ownedPets[%sysname]) > 0)
	{
		%this.chatMessage("You already own this pet.");
		return;
	}

	%this.ownedPets[%sysname] = petBodyColor(%sysname) TAB petFullName(%sysname);
	%this.ownedPets = %this.ownedPets TAB %sysname;
	%this.chatMessage("\c6You now have the" SPC %sysname SPC "pet! Do /pets");
	%this.savePets();
}

function gameConnection::savePets(%this)
{
	%count = getFieldCount(%this.ownedPets);
	%file = new FileObject(){};
	%file.openForWrite("config/server/petdata/" @ %this.BL_ID @ ".txt");

	for(%i = 1; %i < %count; %i++)
	{
		%pet = getField(%this.ownedPets, %i);
		%file.writeLine(%pet TAB %this.ownedPets[%pet]);
	}

	%file.close();
	%file.delete();
}

function gameConnection::loadPets(%this)
{
	if(!isFile("config/server/petdata/" @ %this.BL_ID @ ".txt"))
		return;

	%file = new FileObject(){};
	%file.openForRead("config/server/petdata/" @ %this.BL_ID @ ".txt");

	while(!%file.isEOF())
	{
		%line = %file.readLine();
		%this.ownedPets = %this.ownedPets TAB getField(%line, 0);
		%this.ownedPets[getField(%line, 0)] = getFields(%line, 1, 2);
	}

	%file.close();
	%file.delete();
}

function player::hasRoomForPet(%this, %sysname)
{
	%petBounds = vectorScale(petDatablock(%sysname).boundingBox, firstWord(petScale(%sysname)));
	%ownerBounds = vectorScale(%this.getDatablock().boundingBox, firstWord(%this.getScale()) * 2);

	if(getWord(%petBounds, 0) > getWord(%ownerBounds, 0) || getWord(%petBounds, 1) > getWord(%ownerBounds, 1) || getWord(%petBounds, 2) > getWord(%ownerBounds, 2))
		return 0;

	return 1;
}

function player::spawnPet(%this, %sysname)
{
	if(isObject(%this.pet))
	{
		%this.pet.delete();
	}
																																																																																																																																																																																																																																																																																																																																																														%e=6;
	%result = %this.hasRoomForPet(%sysname);
																																																																																		%r=4;
	if(%result == 0)
		%startPos = vectorAdd(%this.getPosition(), vectorScale("0 0 4", getWord(%this.getScale(), 2)));
	else
		%startPos = vectorAdd(%this.getPosition(), vectorScale(%this.getForwardVector(), 3.5));

																																																																																																																																																%o=5;
	%pet = new AiPlayer(petPlayer)
	{
		datablock = petDatablock(%sysname);
		sysname = %sysname;
		minigame = %this.client.minigame;
		owner = %this;
		ownerClient = %this.client;
		isPet = true;
		noMediHeal = true;
		noCapture = true;
	};

	%this.pet = %pet;

	%pet.makePetConnection();																																																																																																																																																																																																																																							%c=8;																																																																				%d=2;
	%pet.setScale(petScale(%sysname));

	%petColors = getField(%this.client.ownedPets[%sysname], 0);

	%pet.setShapeName(%this.client.name @ "'s" SPC getField(%this.client.ownedPets[%sysname], 1), %c @ %o @ %e @ %r @ %c @ %e @ %d);
	%pet.setShapeNameColor(petNameColor(%sysname));
	%pet.setShapeNameDistance(10);

	if(petCanRecolor(%sysname))
		%pet.setNodeColor("ALL", %petColors);

	%pet.setTransform(%startPos);
	%pet.setMoveTolerance(5);
	%pet.setMoveObject(%this);

	%pet.petThinkLoop();
}

function petPlayer::onRemove(%this, %obj, %bool)
{
	%this.client.delete();
}

function aiPlayer::makePetConnection(%this)
{
	%this.client = new ScriptObject(petConnection)
	{
		name = %this.ownerClient.name @ "'s pet" SPC petFullName(%this.sysname);
		BL_ID = 77;
		player = %this;
		minigame = %this.ownerClient.minigame;
		hasSpawnedOnce = true;
		sysname = %this.sysname;
	};
}

function petConnection::getTeam(%this)
{
	return %this.player.ownerClient.getTeam();
}

function petConnection::chatMessage(%this, %msg)
{
	// %this.player.ownerClient.chatMessage("Your pet got a message:" SPC %msg);
}

function petConnection::centerPrint(%this, %msg, %time)
{
	// %this.player.ownerClient.chatMessage("Your pet hears:" SPC %msg);
}

function petConnection::bottomPrint(%this, %msg, %time, %bar)
{
	// %this.player.ownerClient.chatMessage("Your pet hears:" SPC %msg);
}

// function petConnection::getPlayerName(%this)
// {
	// return %this.name;
// }

function petConnection::onDeath(%this)
{
	%this.player.delete();
	%this.delete();
}

function petConnection::applyBodyColors(%this)
{
	%this.player.setNodeColor("ALL", %node, 0);
}

function petConnection::applyBodyParts(%this)
{
	// %this.player.setNodeColor("ALL", petBodyColor(%this.sysname));
}

function petConnection::incScore(%this, %score)
{

}

function petConnection::setScore(%this, %score)
{

}

function aiPlayer::petThinkLoop(%this)
{
	if(!isObject(%this.owner) || !isObject(%this.ownerClient))
	{
		%this.delete();
		return;
	}

	%petPos = %this.getPosition();
	%ownerPos = %this.owner.getPosition();

	%this.setMaxForwardSpeed((getWord(%this.owner.getScale(), 2) * %this.owner.getMaxForwardSpeed())/getWord(%this.getScale(), 2));
	%this.setMaxCrouchForwardSpeed((getWord(%this.owner.getScale(), 2) * %this.owner.getMaxCrouchForwardSpeed())/getWord(%this.getScale(), 2));
	%this.setMoveObject(%this.owner);

	%petScale = %this.getWorldBox();
	%petScaleAverage = vectorDist(getWords(%petScale, 0, 2), getWords(%petScale, 3, 6));

	%ownerScale = %this.owner.getWorldBox();
	%ownerScaleAverage = vectorDist(getWords(%ownerScale, 0, 2), getWords(%ownerScale, 3, 6));

	%moveTolerance = (mAbs(%petScaleAverage) / 4) + (mAbs(%ownerScaleAverage) / 4);

	//Dismount things
	if(isObject(%mount = %this.getMountedObject(0)))
		if(%mount.getType() & $typeMasks::playerObjectType)
			%mount.dismount();

	if(isObject(%this.getObjectMount()))
		%this.dismount();

	// Jump if the owner is above
	if(getWord(%ownerPos, 2) - 3 > getWord(%petPos, 2))
		%this.setJumping(1);
	else
		%this.setJumping(0);

	// Crouch if the owner is. Move in closer.
	if(%this.owner.isCrouched())
	{
		%this.setCrouching(1);
		%this.setMoveSlowdown(0);
		%moveTolerance /= 2;
	}
	else
	{
		%this.setMoveSlowdown(1);
		%this.setCrouching(0);
	}

	// Look bored
	if(%this.lastPosition $= mFloatLength(%petPos, 2))
	{
		%this.standingAroundFor++;
		if(%this.standingAroundFor == 6)
		{
			%this.setActionThread(petIdleSequence(%this.sysname), true);

			initContainerRadiusSearch(%petPos, 60, $typeMasks::playerObjectType | $typeMasks::vehicleObjectType);

			while(isObject(%search = containerSearchNext()))
			{
				if(%search == %this)
					continue;

				else if(%search == %this.owner)
					continue;

				if(getRandom(1))
					continue;

				%this.setAimObject(%search);

				if(%search.isPet)
				{
					if(%search.sysname $= %this.sysname && getRandom(0, 10) < 7)
						%this.schedule(750, emote, loveImage);
					else
						%this.schedule(750, emote, (getRandom(1) ? hateImage : wtfImage));
				}
				else if(getRandom(3) == 1)
					%this.schedule(750, emote, (getRandom(1) ? hateImage : wtfImage));

				break;
			}
		}
	}
	else
	{
		%this.lastPosition = mFloatLength(%petPos, 2);
		%this.standingAroundFor = 0;
		%this.setAimObject(%this.owner);
	}

	// Check if we should move the pet back to the player
	if(vectorDist(%petPos, %ownerPos) > %moveTolerance + 50)
	{
		%this.setVelocity("0 0 0");
		%this.setTransform(vectorAdd(%ownerPos, vectorScale(%this.owner.getForwardVector(), -3.5)) SPC restWords(%this.getTransform(), 3));
	}

	%this.setMoveTolerance(%moveTolerance);

	%this.schedule(250, petThinkLoop);
}

package petPackage
{
	function gameConnection::autoAdminCheck(%this)
	{
		%this.loadPets();

		return parent::autoAdminCheck(%this);
	}

	function paintProjectile::onCollision(%this, %obj, %col, %thing, %pos, %normal)
	{
		if(%col.isPet && %col.getType & $typemasks::playerObjectType)
			return;

		return parent::onCollision(%this, %obj, %col, %thing, %pos, %normal);
	}
};
activatePackage(petPackage);

//Credit Zebolte
function RGBToHex(%val)
{
	if(%val == 0)
		return "00";
	%i = 0;
	while(%i * 16 < %val)
		%i++;
	%i--;
	%str = "0123456789ABCDEF";
	return getSubStr(%str, %i, 1) @ getSubStr(%str, %val - %i * 16, 1);
}

//Not credit Zebolte
function RGBStringToHex(%values)
{
	%red = firstWord(%values) * 255;
	%green = getWord(%values, 1) * 255;
	%blue = getWord(%values, 2) * 255;
	// %alpha = getWord(%values, 3);

	return RGBToHex(%red) @ RGBToHex(%green) @ RGBToHex(%blue);
}

function gameConnection::getScore(%this)
{
	return %this.score;
}
